//
//  LSThreadPoolThread.h
//  Lightstreamer Thread Pool Library
//
//  Created by Gianluca Bertani on 18/09/12.
//  Copyright 2013 Weswit Srl
//
//  Licensed under the Apache License, Version 2.0 (the "License");
//  you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
//  Unless required by applicable law or agreed to in writing, software
//  distributed under the License is distributed on an "AS IS" BASIS,
//  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//  See the License for the specific language governing permissions and
//  limitations under the License.
//

#import <Foundation/Foundation.h>


@class LSThreadPool;

@interface LSThreadPoolThread : NSThread {
	LSThreadPool *_pool;
	NSString *_name;
	NSMutableArray *_queue;
	NSCondition *_queueMonitor;
	
	NSTimeInterval _loopInterval;
    NSTimeInterval _lastActivity;
	BOOL _running;
	BOOL _working;
}


#pragma mark -
#pragma mark Initialization

+ (LSThreadPoolThread *) threadWithPool:(LSThreadPool *)pool name:(NSString *)name queue:(NSMutableArray *)queue queueMonitor:(NSCondition *)queueMonitor;
- (id) initWithPool:(LSThreadPool *)pool name:(NSString *)name queue:(NSMutableArray *)queue queueMonitor:(NSCondition *)queueMonitor;

- (void) dispose;


#pragma mark -
#pragma mark Properties

@property (nonatomic, readonly) BOOL working;
@property (nonatomic, readonly) NSTimeInterval lastActivity;


@end
